-- Interface:FS17",
-- Title: VehicleCameraAutoZoom",
-- Notes: VehicleCameraAutoZoom",
-- Author: [LSMT]19BlueDragon83",
-- Version: 1.0.0.0",
-- Date: 24.11.2021", 
-- Web: https://forum.ls-mapping-team.de/";;
-- Nach einer Idee von Marhu";;

VehicleCameraAutoZoom = {};

function VehicleCameraAutoZoom.prerequisitesPresent(specializations)
    return true 
end;

function VehicleCameraAutoZoom:load(xmlFile)
end;

function VehicleCameraAutoZoom:delete()
end;

function VehicleCameraAutoZoom:readStream(streamId, connection)
end;

function VehicleCameraAutoZoom:writeStream(streamId, connection)
end;

function VehicleCameraAutoZoom:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleCameraAutoZoom:keyEvent(unicode, sym, modifier, isDown)
end;

function VehicleCameraAutoZoom.registerEventListeners(vehicleType)    
  for _,n in pairs( {"onEnterVehicle", "onLeaveVehicle"} ) do
    SpecializationUtil.registerEventListener(vehicleType, n, VehicleCameraAutoZoom)
  end 
end

function VehicleCameraAutoZoom:init(vehicle)
	vehicle.VehicleCameraAutoZoom = {};
	vehicle.VehicleCameraAutoZoom.initialized = true;

	if vehicle.spec_enterable ~= nil then
		for camIndex, camera in pairs(vehicle.spec_enterable.cameras) do
			if camera.isInside == false and camera.transMax ~= nil then
				vehicle.spec_enterable:setActiveCameraIndex(camIndex);
				camera.zoomTarget = math.min(camera.transMax, math.max(camera.transMin, camera.zoomTarget + 12))
				vehicle.VehicleCameraAutoZoom.initialized = false
			end;
		end;
	end;
end;

function VehicleCameraAutoZoom:onEnterVehicle()

	if self.spec_enterable ~= nil and self.getIsEntered ~= nil and self:getIsEntered() then
		if self.VehicleCameraAutoZoom == nil then
			VehicleCameraAutoZoom:init(self);
		else
			if g_gameSettings:getValue("resetCamera") then
			VehicleCameraAutoZoom:init(self);
			end;
		end;
	end;
end;

function VehicleCameraAutoZoom:onLeaveVehicle()

end;


function VehicleCameraAutoZoom:updateTick(dt)
end;

function VehicleCameraAutoZoom:draw()

end;

function VehicleCameraAutoZoom:onLeave()

end;

function VehicleCameraAutoZoom:onEnter(isControlling)

end

addModEventListener(VehicleCameraAutoZoom);